
/**
 * @return {String} human readble byte-size-string
 * @param {int} bytes 
 * @param {boolean} si if true: use 1000 as base (kB), else 1024 (KiB)
 */
export function bytesToHuman(bytes, si = false) {
  const thresh = si ? 1000 : 1024;
  if (Math.abs(bytes) < thresh) {
    return bytes + ' B';
  }
  const units = si ?
   ['kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'] :
   ['KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'];
  let u = -1;
  do {
    bytes /= thresh;
    ++u;
  } while (Math.abs(bytes) >= thresh && u < units.length - 1);
  return bytes.toFixed(1) + ' ' + units[u];
}
